﻿
using System.Collections;
using Mapbox.Unity.Location;
using Mapbox.Unity.Map;
using UnityEngine;

public class InitializeMapWithLocationProvider : MonoBehaviour
{
	[SerializeField]
	AbstractMap _map;

	ILocationProvider _locationProvider;

	private void Awake()
	{
		// Prevent double initialization of the map. 
		_map.InitializeOnStart = false;
	}

	protected virtual IEnumerator Start()
	{
		yield return null;
		_locationProvider = LocationProviderFactory.Instance.DefaultLocationProvider;
        _locationProvider.OnLocationUpdated += _locationProvider_OnLocationUpdated;
	}

    private void _locationProvider_OnLocationUpdated(Location location)
    {
		_locationProvider.OnLocationUpdated -= _locationProvider_OnLocationUpdated;
		_map.Initialize(location.LatitudeLongitude, _map.AbsoluteZoom);
	}
}
