﻿using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine;
using Mapbox.Utils;

public class RouteTracer : MonoBehaviour
{
    //Mettre ce code sur l'objet ORIGIN 

    [SerializeField] Transform objA;
    [SerializeField] Transform objB;
    public float rayLength = 20.0f;
    public Material mat;
    private List<Transform> wp_points;
    public Transform _prefabs_parent;

    //private
    [SerializeField] bool test = false;

    private void Start()
    {
        StartCoroutine(CreateLine());
    }

    IEnumerator CreateLine()
    {
        yield return new WaitUntil(() => WaypointsFactory.getInstance().getTest() == false);
        Debug.Log(WaypointsFactory.getInstance().getTest());
        wp_points = WaypointsFactory.getInstance().getWp();

        objA = GameObject.FindGameObjectWithTag("start_wp").transform;
        objB = GameObject.FindGameObjectWithTag("end_wp").transform;

        for (int i = 0; i<wp_points.Count-1; i++)
        {
            if (i == 0)
            {
                objA = GameObject.FindGameObjectWithTag("start_wp").transform;
                objB = wp_points[i + 1];
            }
            else if (i == wp_points.Count - 2)
            {
                objA = wp_points[i];
                objB = GameObject.FindGameObjectWithTag("end_wp").transform;
            }
            else
            {
                objA = wp_points[i];
                objB = wp_points[i + 1];
            }

            DrawLine(objA.transform.position, objB.transform.position, Color.cyan, 1f);
        }

        GameObject.Find("Player").transform.position =
            new Vector3(
                 (float)((GameObject.FindGameObjectWithTag("start_wp").transform.position.x + GameObject.FindGameObjectWithTag("end_wp").transform.position.x) / 2d),
                 GameObject.Find("Player").transform.position.y,
                 (float)((GameObject.FindGameObjectWithTag("start_wp").transform.position.z + GameObject.FindGameObjectWithTag("end_wp").transform.position.z) / 2d)
                );

        GameObject.Find("Sportifs").GetComponent<RunnersFactory>().enabled = true;
    }

    void DrawLine(Vector3 start, Vector3 end, Color color, float width)
    {
        test = true;
        GameObject myLine = new GameObject();
        myLine.transform.position = start;
        myLine.AddComponent<LineRenderer>();
        myLine.transform.parent = _prefabs_parent;
        LineRenderer lr = myLine.GetComponent<LineRenderer>();
        lr.material = mat;
        lr.startColor = color;
        lr.endColor = color;
        lr.startWidth = width;
        lr.endWidth = width;
        lr.SetPosition(0, start);
        lr.SetPosition(1, end);
    }
}